# QEMU CPU Emulator User Documentation

# Table of Contents

- 1. Introduction
  - 1.1 Features
- 2. Installation
  - 2.1 Linux
  - 2.2 Windows
  - 2.3 Mac OS X
- 3. QEMU PC System emulator
  - 3.1 Introduction
  - 3.2 Quick Start
  - 3.3 Invocation
  - 3.4 Keys
  - 3.5 QEMU Monitor
    - 3.5.1 Commands
    - 3.5.2 Integer expressions
  - 3.6 Disk Images
    - 3.6.1 Quick start for disk image creation
    - 3.6.2 Snapshot mode
    - 3.6.3 `qemu-img` Invocation
    - 3.6.4 Virtual FAT disk images
  - 3.7 Network emulation
    - 3.7.1 VLANs
    - 3.7.2 Using TAP network interfaces
    - 3.7.3 Using the user mode network stack
    - 3.7.4 Connecting VLANs between QEMU instances
  - 3.8 Direct Linux Boot
  - 3.9 USB emulation
    - 3.9.1 Using virtual USB devices
    - 3.9.2 Using host USB devices on a Linux host
  - 3.10 GDB usage
  - 3.11 Target OS specific information
    - 3.11.1 Linux
    - 3.11.2 Windows
      - 3.11.2.1 SVGA graphic modes support
      - 3.11.2.2 CPU usage reduction
      - 3.11.2.3 Windows 2000 disk full problem
      - 3.11.2.4 Windows 2000 shutdown
      - 3.11.2.5 Share a directory between Unix and Windows
      - 3.11.2.6 Windows XP security problems
    - 3.11.3 MS-DOS and FreeDOS
      - 3.11.3.1 CPU usage reduction
- 4. QEMU System emulator for non PC targets
  - 4.1 QEMU PowerPC System emulator
  - 4.2 Sparc32 System emulator invocation
  - 4.3 Sparc64 System emulator invocation
  - 4.4 MIPS System emulator invocation
  - 4.5 ARM System emulator invocation
- 5. QEMU Linux User space emulator
  - 5.1 Quick Start
  - 5.2 Wine launch
  - 5.3 Command line options
- 6. Compilation from the sources
  - 6.1 Linux/Unix
    - 6.1.1 Compilation
    - 6.1.2 Tested tool versions
  - 6.2 Windows
  - 6.3 Cross compilation for Windows with Linux
  - 6.4 Mac OS X
- 7. Index

# 1. Introduction

## 1.1 Features

QEMU is a FAST! processor emulator using dynamic translation to achieve good emulation speed.

QEMU has two operating modes:

- Full system emulation. In this mode, QEMU emulates a full system (for example a PC), including one or several processors and various peripherals. It can be used to launch different Operating Systems without rebooting the PC or to debug system code.
- User mode emulation (Linux host only). In this mode, QEMU can launch Linux processes compiled for one CPU on another CPU. It can be used to launch the Wine Windows API emulator (http://www.winehq.org) or to ease cross-compilation and cross-debugging.

QEMU can run without an host kernel driver and yet gives acceptable performance.

For system emulation, the following hardware targets are supported:

- PC (x86 or x86_64 processor)
- ISA PC (old style PC without PCI bus)
- PREP (PowerPC processor)
- G3 BW PowerMac (PowerPC processor)
- Mac99 PowerMac (PowerPC processor, in progress)
- Sun4m (32-bit Sparc processor)
- Sun4u (64-bit Sparc processor, in progress)
- Malta board (32-bit MIPS processor)
- ARM Integrator/CP (ARM926E or 1026E processor)

For user emulation, x86, PowerPC, ARM, MIPS, and Sparc32/64 CPUs are supported.

# 2. Installation

If you want to compile QEMU yourself, see section 6. Compilation from the sources.

## 2.1 Linux

If a precompiled package is available for your distribution - you just have to install it. Otherwise, see section 6. Compilation from the sources.

## 2.2 Windows

Download the experimental binary installer at http://www.free.oszoo.org/@/download.html.

## 2.3 Mac OS X

Download the experimental binary installer at http://www.free.oszoo.org/@/download.html.

# 3. QEMU PC System emulator

## 3.1 Introduction

The QEMU PC System emulator simulates the following peripherals:

- i440FX host PCI bridge and PIIX3 PCI to ISA bridge
- Cirrus CLGD 5446 PCI VGA card or dummy VGA card with Bochs VESA extensions (hardware level, including all non standard modes).
- PS/2 mouse and keyboard
- 2 PCI IDE interfaces with hard disk and CD-ROM support
- Floppy disk
- NE2000 PCI network adapters
- Serial ports
- Creative SoundBlaster 16 sound card
- ENSONIQ AudioPCI ES1370 sound card
- Adlib(OPL2) - Yamaha YM3812 compatible chip
- PCI UHCI USB controller and a virtual USB hub.

SMP is supported with up to 255 CPUs.

Note that adlib is only available when QEMU was configured with -enable-adlib

QEMU uses the PC BIOS from the Bochs project and the Plex86/Bochs LGPL VGA BIOS.

QEMU uses YM3812 emulation by Tatsuyuki Satoh.

## 3.2 Quick Start

Download and uncompress the linux image (``linux.img'`) and type:

    qemu linux.img

Linux should boot and give you a prompt.

## 3.3 Invocation

    usage: qemu [options] [disk_image]

disk_image is a raw hard disk image for IDE hard disk 0.

General options:

``-M machine'`
  Select the emulated machine (`-M ?` for list)
``-fda file'`
``-fdb file'`
  Use file as floppy disk 0/1 image (see section 3.6 Disk Images). You can use the host floppy by using ``/dev/fd0'` as filename.
``-hda file'`
``-hdb file'`
``-hdc file'`
``-hdd file'`
  Use file as hard disk 0, 1, 2 or 3 image (see section 3.6 Disk Images).
``-cdrom file'`
  Use file as CD-ROM image (you cannot use ``-hdc'` and and ``-cdrom'` at the same time). You can use the host CD-ROM by using ``/dev/cdrom'` as filename.
``-boot [a|c|d]'`
  Boot on floppy (a), hard disk (c) or CD-ROM (d). Hard disk boot is the default.
``-snapshot'`
  Write to temporary files instead of disk image files. In this case, the raw disk image you use is not written back. You can however force the write back by pressing `C-a s` (see section 3.6 Disk Images).
``-m megs'`
  Set virtual RAM size to megs megabytes. Default is 128 MB.
``-smp n'`
  Simulate an SMP system with n CPUs. On the PC target, up to 255 CPUs are supported.
``-nographic'`
  Normally, QEMU uses SDL to display the VGA output. With this option, you can totally disable graphical output so that QEMU is a simple command line application. The emulated serial port is redirected on the console. Therefore, you can still use QEMU to debug a Linux kernel with a serial console.
``-vnc d'`
  Normally, QEMU uses SDL to display the VGA output. With this option, you can have QEMU listen on VNC display d and redirect the VGA display over the VNC session. It is very useful to enable the usb tablet device when using this option (option ``-usbdevice tablet'`).
``-k language'`
  Use keyboard layout language (for example `fr` for French). This option is only needed where it is not easy to get raw PC keycodes (e.g. on Macs or with some X11 servers). You don't need to use it on PC/Linux or PC/Windows hosts. The available layouts are:

      ar  de-ch  es  fo     fr-ca  hu  ja  mk     no  pt-br  sv
      da  en-gb  et  fr     fr-ch  is  lt  nl     pl  ru     th
      de  en-us  fi  fr-be  hr     it  lv  nl-be  pt  sl     tr

  The default is `en-us`.
``-audio-help'`
  Will show the audio subsystem help: list of drivers, tunable parameters.
``-soundhw card1,card2,... or -soundhw all'`
  Enable audio and selected sound hardware. Use ? to print all available sound hardware.

      qemu -soundhw sb16,adlib hda
      qemu -soundhw es1370 hda
      qemu -soundhw all hda
      qemu -soundhw ?

``-localtime'`
  Set the real time clock to local time (the default is to UTC time). This option is needed to have correct date in MS-DOS or Windows.
``-full-screen'`
  Start in full screen.
``-pidfile file'`
  Store the QEMU process PID in file. It is useful if you launch QEMU from a script.
``-win2k-hack'`
  Use it when installing Windows 2000 to avoid a disk full bug. After Windows 2000 is installed, you no longer need this option (this option slows down the IDE transfers).

USB options:

``-usb'`
  Enable the USB driver (will be the default soon)
``-usbdevice devname'`
  Add the USB device devname. See the monitor command `usb_add` to have more information.

Network options:

``-net nic[,vlan=n][,macaddr=addr][,model=type]'`
  Create a new Network Interface Card and connect it to VLAN n (n = 0 is the default). The NIC is currently an NE2000 on the PC target. Optionally, the MAC address can be changed. If no ``-net'` option is specified, a single NIC is created. Qemu can emulate several different models of network card. Valid values for type are `ne2k_pci`, `ne2k_isa`, `rtl8139`, `smc91c111` and `lance`. Not all devices are supported on all targets.
``-net user[,vlan=n][,hostname=name]'`
  Use the user mode network stack which requires no administrator priviledge to run. ``hostname=name'` can be used to specify the client hostname reported by the builtin DHCP server.
``-net tap[,vlan=n][,fd=h][,ifname=name][,script=file]'`
  Connect the host TAP network interface name to VLAN n and use the network script file to configure it. The default network script is ``/etc/qemu-ifup'`. If name is not provided, the OS automatically provides one. ``fd=h'` can be used to specify the handle of an already opened host TAP interface. Example:

      qemu linux.img -net nic -net tap

  More complicated example (two NICs, each one connected to a TAP device)

      qemu linux.img -net nic,vlan=0 -net tap,vlan=0,ifname=tap0 \
                     -net nic,vlan=1 -net tap,vlan=1,ifname=tap1

``-net socket[,vlan=n][,fd=h][,listen=[host]:port][,connect=host:port]'`
  Connect the VLAN n to a remote VLAN in another QEMU virtual machine using a TCP socket connection. If ``listen'` is specified, QEMU waits for incoming connections on port (host is optional). ``connect'` is used to connect to another QEMU instance using the ``listen'` option. ``fd=h'` specifies an already opened TCP socket. Example:

      # launch a first QEMU instance
      qemu linux.img -net nic,macaddr=52:54:00:12:34:56 \
                     -net socket,listen=:1234
      # connect the VLAN 0 of this instance to the VLAN 0
      # of the first instance
      qemu linux.img -net nic,macaddr=52:54:00:12:34:57 \
                     -net socket,connect=127.0.0.1:1234

``-net socket[,vlan=n][,fd=h][,mcast=maddr:port]'`
  Create a VLAN n shared with another QEMU virtual machines using a UDP multicast socket, effectively making a bus for every QEMU with same multicast address maddr and port. NOTES:
  1. Several QEMU can be running on different hosts and share same bus (assuming correct multicast setup for these hosts).
  2. mcast support is compatible with User Mode Linux (argument ``ethN=mcast'`), see http://user-mode-linux.sf.net.
  3. Use ``fd=h'` to specify an already opened UDP multicast socket.
  Example:

      # launch one QEMU instance
      qemu linux.img -net nic,macaddr=52:54:00:12:34:56 \
                     -net socket,mcast=230.0.0.1:1234
      # launch another QEMU instance on same "bus"
      qemu linux.img -net nic,macaddr=52:54:00:12:34:57 \
                     -net socket,mcast=230.0.0.1:1234
      # launch yet another QEMU instance on same "bus"
      qemu linux.img -net nic,macaddr=52:54:00:12:34:58 \
                     -net socket,mcast=230.0.0.1:1234

  Example (User Mode Linux compat.):

      # launch QEMU instance (note mcast address selected
      # is UML's default)
      qemu linux.img -net nic,macaddr=52:54:00:12:34:56 \
                     -net socket,mcast=239.192.168.1:1102
      # launch UML
      /path/to/linux ubd0=/path/to/root_fs eth0=mcast

``-net none'`
  Indicate that no network devices should be configured. It is used to override the default configuration (``-net nic -net user'`) which is activated if no ``-net'` options are provided.
``-tftp prefix'`
  When using the user mode network stack, activate a built-in TFTP server. All filenames beginning with prefix can be downloaded from the host to the guest using a TFTP client. The TFTP client on the guest must be configured in binary mode (use the command `bin` of the Unix TFTP client). The host IP address on the guest is as usual 10.0.2.2.
``-smb dir'`
  When using the user mode network stack, activate a built-in SMB server so that Windows OSes can access to the host files in ``dir'` transparently. In the guest Windows OS, the line:

      10.0.2.4 smbserver

  must be added in the file ``C:\WINDOWS\LMHOSTS'` (for windows 9x/Me) or ``C:\WINNT\SYSTEM32\DRIVERS\ETC\LMHOSTS'` (Windows NT/2000). Then ``dir'` can be accessed in ``\\smbserver\qemu'`. Note that a SAMBA server must be installed on the host OS in ``/usr/sbin/smbd'`. QEMU was tested succesfully with smbd version 2.2.7a from the Red Hat 9 and version 3.0.10-1.fc3 from Fedora Core 3.
``-redir [tcp|udp]:host-port:[guest-host]:guest-port'`
  When using the user mode network stack, redirect incoming TCP or UDP connections to the host port host-port to the guest guest-host on guest port guest-port. If guest-host is not specified, its value is 10.0.2.15 (default address given by the built-in DHCP server). For example, to redirect host X11 connection from screen 1 to guest screen 0, use the following:

      # on the host
      qemu -redir tcp:6001::6000 [...]
      # this host xterm should open in the guest X11 server
      xterm -display :1

  To redirect telnet connections from host port 5555 to telnet port on the guest, use the following:

      # on the host
      qemu -redir tcp:5555::23 [...]
      telnet localhost 5555

  Then when you use on the host `telnet localhost 5555`, you connect to the guest telnet server.

Linux boot specific: When using these options, you can use a given Linux kernel without installing it in the disk image. It can be useful for easier testing of various kernels.

``-kernel bzImage'`
  Use bzImage as kernel image.
``-append cmdline'`
  Use cmdline as kernel command line
``-initrd file'`
  Use file as initial ram disk.

Debug/Expert options:

``-serial dev'`
  Redirect the virtual serial port to host device dev. Available devices are:
  `vc`
    Virtual console
  `pty`
    [Linux only] Pseudo TTY (a new PTY is automatically allocated)
  `null`
    void device
  `/dev/XXX`
    [Linux only] Use host tty, e.g. ``/dev/ttyS0'`. The host serial port parameters are set according to the emulated ones.
  `/dev/parportN`
    [Linux only, parallel port only] Use host parallel port N. Currently only SPP parallel port features can be used.
  `file:filename`
    Write output to filename. No character can be read.
  `stdio`
    [Unix only] standard input/output
  `pipe:filename`
    [Unix only] name pipe filename
  The default device is `vc` in graphical mode and `stdio` in non graphical mode. This option can be used several times to simulate up to 4 serials ports.
``-parallel dev'`
  Redirect the virtual parallel port to host device dev (same devices as the serial port). On Linux hosts, ``/dev/parportN'` can be used to use hardware devices connected on the corresponding host parallel port. This option can be used several times to simulate up to 3 parallel ports.
``-monitor dev'`
  Redirect the monitor to host device dev (same devices as the serial port). The default device is `vc` in graphical mode and `stdio` in non graphical mode.
``-s'`
  Wait gdb connection to port 1234 (see section 3.10 GDB usage).
``-p port'`
  Change gdb connection port.
``-S'`
  Do not start CPU at startup (you must type 'c' in the monitor).
``-d'`
  Output log in /tmp/qemu.log
``-hdachs c,h,s,[,t]'`
  Force hard disk 0 physical geometry (1 <= c <= 16383, 1 <= h <= 16, 1 <= s <= 63) and optionally force the BIOS translation mode (t=none, lba or auto). Usually QEMU can guess all thoses parameters. This option is useful for old MS-DOS disk images.
``-std-vga'`
  Simulate a standard VGA card with Bochs VBE extensions (default is Cirrus Logic GD5446 PCI VGA)
``-loadvm file'`
  Start right away with a saved state (`loadvm` in monitor)

## 3.4 Keys

During the graphical emulation, you can use the following keys:

`Ctrl-Alt-f`
  Toggle full screen
`Ctrl-Alt-n`
  Switch to virtual console 'n'. Standard console mappings are:
  1
    Target system display
  2
    Monitor
  3
    Serial port
`Ctrl-Alt`
  Toggle mouse and keyboard grab.

In the virtual consoles, you can use `Ctrl-Up`, `Ctrl-Down`, `Ctrl-PageUp` and `Ctrl-PageDown` to move in the back log.

During emulation, if you are using the ``-nographic'` option, use `Ctrl-a h` to get terminal commands:

`Ctrl-a h`
  Print this help
`Ctrl-a x`
  Exit emulatior
`Ctrl-a s`
  Save disk data back to file (if -snapshot)
`Ctrl-a b`
  Send break (magic sysrq in Linux)
`Ctrl-a c`
  Switch between console and monitor
`Ctrl-a Ctrl-a`
  Send Ctrl-a

## 3.5 QEMU Monitor

The QEMU monitor is used to give complex commands to the QEMU emulator. You can use it to:

- Remove or insert removable medias images (such as CD-ROM or floppies)
- Freeze/unfreeze the Virtual Machine (VM) and save or restore its state from a disk file.
- Inspect the VM state without an external debugger.

### 3.5.1 Commands

The following commands are available:

``help or ? [cmd]'`
  Show the help for all commands or just for command cmd.
``commit'`
  Commit changes to the disk images (if -snapshot is used)
``info subcommand'`
  show various information about the system state
  ``info network'`
    show the various VLANs and the associated devices
  ``info block'`
    show the block devices
  ``info registers'`
    show the cpu registers
  ``info history'`
    show the command line history
  ``info pci'`
    show emulated PCI device
  ``info usb'`
    show USB devices plugged on the virtual USB hub
  ``info usbhost'`
    show all USB host devices
``q or quit'`
  Quit the emulator.
``eject [-f] device'`
  Eject a removable media (use -f to force it).
``change device filename'`
  Change a removable media.
``screendump filename'`
  Save screen into PPM image filename.
``log item1[,...]'`
  Activate logging of the specified items to ``/tmp/qemu.log'`.
``savevm filename'`
  Save the whole virtual machine state to filename.
``loadvm filename'`
  Restore the whole virtual machine state from filename.
``stop'`
  Stop emulation.
``c or cont'`
  Resume emulation.
``gdbserver [port]'`
  Start gdbserver session (default port=1234)
``x/fmt addr'`
  Virtual memory dump starting at addr.
``xp /fmt addr'`
  Physical memory dump starting at addr. fmt is a format which tells the command how to format the data. Its syntax is: ``/{count}{format}{size}'`
  count
    is the number of items to be dumped.
  format
    can be x (hexa), d (signed decimal), u (unsigned decimal), o (octal), c (char) or i (asm instruction).
  size
    can be b (8 bits), h (16 bits), w (32 bits) or g (64 bits). On x86, `h` or `w` can be specified with the `i` format to respectively select 16 or 32 bit code instruction size.
  Examples:
  - Dump 10 instructions at the current instruction pointer:

        (qemu) x/10i $eip
        0x90107063:  ret
        0x90107064:  sti
        0x90107065:  lea    0x0(%esi,1),%esi
        0x90107069:  lea    0x0(%edi,1),%edi
        0x90107070:  ret
        0x90107071:  jmp    0x90107080
        0x90107073:  nop
        0x90107074:  nop
        0x90107075:  nop
        0x90107076:  nop

  - Dump 80 16 bit values at the start of the video memory.

        (qemu) xp/80hx 0xb8000
        0x000b8000: 0x0b50 0x0b6c 0x0b65 0x0b78 0x0b38 0x0b36 0x0b2f 0x0b42
        0x000b8010: 0x0b6f 0x0b63 0x0b68 0x0b73 0x0b20 0x0b56 0x0b47 0x0b41
        0x000b8020: 0x0b42 0x0b69 0x0b6f 0x0b73 0x0b20 0x0b63 0x0b75 0x0b72
        0x000b8030: 0x0b72 0x0b65 0x0b6e 0x0b74 0x0b2d 0x0b63 0x0b76 0x0b73
        0x000b8040: 0x0b20 0x0b30 0x0b35 0x0b20 0x0b4e 0x0b6f 0x0b76 0x0b20
        0x000b8050: 0x0b32 0x0b30 0x0b30 0x0b33 0x0720 0x0720 0x0720 0x0720
        0x000b8060: 0x0720 0x0720 0x0720 0x0720 0x0720 0x0720 0x0720 0x0720
        0x000b8070: 0x0720 0x0720 0x0720 0x0720 0x0720 0x0720 0x0720 0x0720
        0x000b8080: 0x0720 0x0720 0x0720 0x0720 0x0720 0x0720 0x0720 0x0720
        0x000b8090: 0x0720 0x0720 0x0720 0x0720 0x0720 0x0720 0x0720 0x0720

``p or print/fmt expr'`
  Print expression value. Only the format part of fmt is used.
``sendkey keys'`
  Send keys to the emulator. Use `-` to press several keys simultaneously. Example:

      sendkey ctrl-alt-f1

  This command is useful to send keys that your graphical user interface intercepts at low level, such as `ctrl-alt-f1` in X Window.
``system_reset'`
  Reset the system.
``usb_add devname'`
  Plug the USB device devname to the QEMU virtual USB hub. devname is either a virtual device name (for example `mouse`) or a host USB device identifier. Host USB device identifiers have the following syntax: `host:bus.addr` or `host:vendor_id:product_id`.
``usb_del devname'`
  Remove the USB device devname from the QEMU virtual USB hub. devname has the syntax `bus.addr`. Use the monitor command `info usb` to see the devices you can remove.

### 3.5.2 Integer expressions

The monitor understands integers expressions for every integer argument. You can use register names to get the value of specifics CPU registers by prefixing them with $.

## 3.6 Disk Images

Since version 0.6.1, QEMU supports many disk image formats, including growable disk images (their size increase as non empty sectors are written), compressed and encrypted disk images.

### 3.6.1 Quick start for disk image creation

You can create a disk image with the command:

    qemu-img create myimage.img mysize

where myimage.img is the disk image filename and mysize is its size in kilobytes. You can add an `M` suffix to give the size in megabytes and a `G` suffix for gigabytes.

See section 3.6.3 `qemu-img` Invocation for more information.

### 3.6.2 Snapshot mode

If you use the option ``-snapshot'`, all disk images are considered as read only. When sectors in written, they are written in a temporary file created in ``/tmp'`. You can however force the write back to the raw disk images by using the `commit` monitor command (or `C-a s` in the serial console).

### 3.6.3 `qemu-img` Invocation

    usage: qemu-img command [command options]

The following commands are supported:

``create [-e] [-b base_image] [-f fmt] filename [size]'`
``commit [-f fmt] filename'`
``convert [-c] [-e] [-f fmt] filename [-O output_fmt] output_filename'`
``info [-f fmt] filename'`

Command parameters:

filename
  is a disk image filename
base_image
  is the read-only disk image which is used as base for a copy on write image; the copy on write image only stores the modified data
fmt
  is the disk image format. It is guessed automatically in most cases. The following formats are supported:
  `raw`
    Raw disk image format (default). This format has the advantage of being simple and easily exportable to all other emulators. If your file system supports holes (for example in ext2 or ext3 on Linux), then only the written sectors will reserve space. Use `qemu-img info` to know the real size used by the image or `ls -ls` on Unix/Linux.
  `qcow`
    QEMU image format, the most versatile format. Use it to have smaller images (useful if your filesystem does not supports holes, for example on Windows), optional AES encryption and zlib based compression.
  `cow`
    User Mode Linux Copy On Write image format. Used to be the only growable image format in QEMU. It is supported only for compatibility with previous versions. It does not work on win32.
  `vmdk`
    VMware 3 and 4 compatible image format.
  `cloop`
    Linux Compressed Loop image, useful only to reuse directly compressed CD-ROM images present for example in the Knoppix CD-ROMs.
size
  is the disk image size in kilobytes. Optional suffixes `M` (megabyte) and `G` (gigabyte) are supported
output_filename
  is the destination disk image filename
output_fmt
  is the destination format
-c
  indicates that target image must be compressed (qcow format only)
-e
  indicates that the target image must be encrypted (qcow format only)

Command description:

``create [-e] [-b base_image] [-f fmt] filename [size]'`
  Create the new disk image filename of size size and format fmt. If base_image is specified, then the image will record only the differences from base_image. No size needs to be specified in this case. base_image will never be modified unless you use the `commit` monitor command.
``commit [-f fmt] filename'`
  Commit the changes recorded in filename in its base image.
``convert [-c] [-e] [-f fmt] filename [-O output_fmt] output_filename'`
  Convert the disk image filename to disk image output_filename using format output_fmt. It can be optionnaly encrypted (`-e` option) or compressed (`-c` option). Only the format `qcow` supports encryption or compression. The compression is read-only. It means that if a compressed sector is rewritten, then it is rewritten as uncompressed data. Encryption uses the AES format which is very secure (128 bit keys). Use a long password (16 characters) to get maximum protection. Image conversion is also useful to get smaller image when using a growable format such as `qcow` or `cow`: the empty sectors are detected and suppressed from the destination image.
``info [-f fmt] filename'`
  Give information about the disk image filename. Use it in particular to know the size reserved on disk which can be different from the displayed size.

### 3.6.4 Virtual FAT disk images

QEMU can automatically create a virtual FAT disk image from a directory tree. In order to use it, just type:

    qemu linux.img -hdb fat:/my_directory

Then you access access to all the files in the ``/my_directory'` directory without having to copy them in a disk image or to export them via SAMBA or NFS. The default access is read-only.

Floppies can be emulated with the `:floppy:` option:

    qemu linux.img -fda fat:floppy:/my_directory

A read/write support is available for testing (beta stage) with the `:rw:` option:

    qemu linux.img -fda fat:floppy:rw:/my_directory

What you should never do:

- use non-ASCII filenames ;
- use "-snapshot" together with ":rw:" ;
- expect it to work when loadvm'ing ;
- write to the FAT directory on the host system while accessing it with the guest system.

## 3.7 Network emulation

QEMU can simulate several networks cards (NE2000 boards on the PC target) and can connect them to an arbitrary number of Virtual Local Area Networks (VLANs). Host TAP devices can be connected to any QEMU VLAN. VLAN can be connected between separate instances of QEMU to simulate large networks. For simpler usage, a non priviledged user mode network stack can replace the TAP device to have a basic network connection.

### 3.7.1 VLANs

QEMU simulates several VLANs. A VLAN can be symbolised as a virtual connection between several network devices. These devices can be for example QEMU virtual Ethernet cards or virtual Host ethernet devices (TAP devices).

### 3.7.2 Using TAP network interfaces

This is the standard way to connect QEMU to a real network. QEMU adds a virtual network device on your host (called `tapN`), and you can then configure it as if it was a real ethernet card.

As an example, you can download the ``linux-test-xxx.tar.gz'` archive and copy the script ``qemu-ifup'` in ``/etc'` and configure properly `sudo` so that the command `ifconfig` contained in ``qemu-ifup'` can be executed as root. You must verify that your host kernel supports the TAP network interfaces: the device ``/dev/net/tun'` must be present.

See section 3.8 Direct Linux Boot to have an example of network use with a Linux distribution and section 3.3 Invocation to have examples of command lines using the TAP network interfaces.

### 3.7.3 Using the user mode network stack

By using the option ``-net user'` (default configuration if no ``-net'` option is specified), QEMU uses a completely user mode network stack (you don't need root priviledge to use the virtual network). The virtual network configuration is the following:

             QEMU VLAN      <------>  Firewall/DHCP server <-----> Internet
                               |          (10.0.2.2)
                               |
                               ---->  DNS server (10.0.2.3)
                               |
                               ---->  SMB server (10.0.2.4)

The QEMU VM behaves as if it was behind a firewall which blocks all incoming connections. You can use a DHCP client to automatically configure the network in the QEMU VM. The DHCP server assign addresses to the hosts starting from 10.0.2.15.

In order to check that the user mode network is working, you can ping the address 10.0.2.2 and verify that you got an address in the range 10.0.2.x from the QEMU virtual DHCP server.

Note that `ping` is not supported reliably to the internet as it would require root priviledges. It means you can only ping the local router (10.0.2.2).

When using the built-in TFTP server, the router is also the TFTP server.

When using the ``-redir'` option, TCP or UDP connections can be redirected from the host to the guest. It allows for example to redirect X11, telnet or SSH connections.

### 3.7.4 Connecting VLANs between QEMU instances

Using the ``-net socket'` option, it is possible to make VLANs that span several QEMU instances. See section 3.3 Invocation to have a basic example.

## 3.8 Direct Linux Boot

This section explains how to launch a Linux kernel inside QEMU without having to make a full bootable image. It is very useful for fast Linux kernel testing. The QEMU network configuration is also explained.

1. Download the archive ``linux-test-xxx.tar.gz'` containing a Linux kernel and a disk image.
2. Optional: If you want network support (for example to launch X11 examples), you must copy the script ``qemu-ifup'` in ``/etc'` and configure properly `sudo` so that the command `ifconfig` contained in ``qemu-ifup'` can be executed as root. You must verify that your host kernel supports the TUN/TAP network interfaces: the device ``/dev/net/tun'` must be present. When network is enabled, there is a virtual network connection between the host kernel and the emulated kernel. The emulated kernel is seen from the host kernel at IP address 172.20.0.2 and the host kernel is seen from the emulated kernel at IP address 172.20.0.1.
3. Launch `qemu.sh`. You should have the following output:

       > ./qemu.sh
       Connected to host network interface: tun0
       Linux version 2.4.21 (bellard@voyager.localdomain) (gcc version 3.2.2 20030222 @/(Red Hat @/Linux 3.2.2-5)) #5 Tue Nov 11 18:18:53 CET 2003
       BIOS-provided physical RAM map:
        BIOS-e801: 0000000000000000 - 000000000009f000 (usable)
        BIOS-e801: 0000000000100000 - 0000000002000000 (usable)
       32MB LOWMEM available.
       On node 0 totalpages: 8192
       zone(0): 4096 pages.
       zone(1): 4096 pages.
       zone(2): 0 pages.
       Kernel command line: root=/dev/hda sb=0x220,5,1,5 ide2=noprobe ide3=noprobe ide4=noprobe @/ide5=noprobe console=ttyS0
       ide_setup: ide2=noprobe
       ide_setup: ide3=noprobe
       ide_setup: ide4=noprobe
       ide_setup: ide5=noprobe
       Initializing CPU#0
       Detected 2399.621 MHz processor.
       Console: colour EGA 80x25
       Calibrating delay loop... 4744.80 BogoMIPS
       Memory: 28872k/32768k available (1210k kernel code, 3508k reserved, 266k data, 64k init, @/0k highmem)
       Dentry cache hash table entries: 4096 (order: 3, 32768 bytes)
       Inode cache hash table entries: 2048 (order: 2, 16384 bytes)
       Mount cache hash table entries: 512 (order: 0, 4096 bytes)
       Buffer-cache hash table entries: 1024 (order: 0, 4096 bytes)
       Page-cache hash table entries: 8192 (order: 3, 32768 bytes)
       CPU: Intel Pentium Pro stepping 03
       Checking 'hlt' instruction... OK.
       POSIX conformance testing by UNIFIX
       Linux NET4.0 for Linux 2.4
       Based upon Swansea University Computer Society NET3.039
       Initializing RT netlink socket
       apm: BIOS not found.
       Starting kswapd
       Journalled Block Device driver loaded
       Detected PS/2 Mouse Port.
       pty: 256 Unix98 ptys configured
       Serial driver version 5.05c (2001-07-08) with no serial options enabled
       ttyS00 at 0x03f8 (irq = 4) is a 16450
       ne.c:v1.10 9/23/94 Donald Becker (becker@scyld.com)
       Last modified Nov 1, 2000 by Paul Gortmaker
       NE*000 ethercard probe at 0x300: 52 54 00 12 34 56
       eth0: NE2000 found at 0x300, using IRQ 9.
       RAMDISK driver initialized: 16 RAM disks of 4096K size 1024 blocksize
       Uniform Multi-Platform E-IDE driver Revision: 7.00beta4-2.4
       ide: Assuming 50MHz system bus speed for PIO modes; override with idebus=xx
       hda: QEMU HARDDISK, ATA DISK drive
       ide0 at 0x1f0-0x1f7,0x3f6 on irq 14
       hda: attached ide-disk driver.
       hda: 20480 sectors (10 MB) w/256KiB Cache, CHS=20/16/63
       Partition check:
        hda:
       Soundblaster audio driver Copyright (C) by Hannu Savolainen 1993-1996
       NET4: Linux TCP/IP 1.0 for NET4.0
       IP Protocols: ICMP, UDP, TCP, IGMP
       IP: routing cache hash table of 512 buckets, 4Kbytes
       TCP: Hash tables configured (established 2048 bind 4096)
       NET4: Unix domain sockets 1.0/SMP for Linux NET4.0.
       EXT2-fs warning: mounting unchecked fs, running e2fsck is recommended
       VFS: Mounted root (ext2 filesystem).
       Freeing unused kernel memory: 64k freed

       Linux version 2.4.21 (bellard@voyager.localdomain) (gcc version 3.2.2 20030222 @/(Red Hat @/Linux 3.2.2-5)) #5 Tue Nov 11 18:18:53 CET 2003

       QEMU Linux test distribution (based on Redhat 9)

       Type 'exit' to halt the system

       sh-2.05b#

4. Then you can play with the kernel inside the virtual serial console. You can launch `ls` for example. Type `Ctrl-a h` to have an help about the keys you can type inside the virtual serial console. In particular, use `Ctrl-a x` to exit QEMU and use `Ctrl-a b` as the Magic SysRq key.
5. If the network is enabled, launch the script ``/etc/linuxrc'` in the emulator (don't forget the leading dot):

       . /etc/linuxrc

   Then enable X11 connections on your PC from the emulated Linux:

       xhost +172.20.0.2

   You can now launch ``xterm'` or ``xlogo'` and verify that you have a real Virtual Linux system !

NOTES:

1. A 2.5.74 kernel is also included in the archive. Just replace the bzImage in qemu.sh to try it.
2. In order to exit cleanly from qemu, you can do a shutdown inside qemu. qemu will automatically exit when the Linux shutdown is done.
3. You can boot slightly faster by disabling the probe of non present IDE interfaces. To do so, add the following options on the kernel command line:

       ide1=noprobe ide2=noprobe ide3=noprobe ide4=noprobe ide5=noprobe

4. The example disk image is a modified version of the one made by Kevin Lawton for the plex86 Project (www.plex86.org).

## 3.9 USB emulation

QEMU emulates a PCI UHCI USB controller and a 8 port USB hub connected to it. You can virtually plug to the hub virtual USB devices or real host USB devices (experimental, works only on Linux hosts).

### 3.9.1 Using virtual USB devices

A virtual USB mouse device is available for testing in QEMU.

You can try it with the following monitor commands:

    # add the mouse device
    (qemu) usb_add mouse

    # show the virtual USB devices plugged on the QEMU Virtual USB hub
    (qemu) info usb
      Device 0.3, speed 12 Mb/s

    # after some time you can try to remove the mouse
    (qemu) usb_del 0.3

The option ``-usbdevice'` is similar to the monitor command `usb_add`.

### 3.9.2 Using host USB devices on a Linux host

WARNING: this is an experimental feature. QEMU will slow down when using it. USB devices requiring real time streaming (i.e. USB Video Cameras) are not supported yet.

1. If you use an early Linux 2.4 kernel, verify that no Linux driver is actually using the USB device. A simple way to do that is simply to disable the corresponding kernel module by renaming it from ``mydriver.o'` to ``mydriver.o.disabled'`.
2. Verify that ``/proc/bus/usb'` is working (most Linux distributions should enable it by default). You should see something like that:

       ls /proc/bus/usb
       001  devices  drivers

3. Since only root can access to the USB devices directly, you can either launch QEMU as root or change the permissions of the USB devices you want to use. For testing, the following suffices:

       chown -R myuid /proc/bus/usb

4. Launch QEMU and do in the monitor:

       info usbhost
         Device 1.2, speed 480 Mb/s
           Class 00: USB device 1234:5678, USB DISK

   You should see the list of the devices you can use (Never try to use hubs, it won't work).
5. Add the device in QEMU by using:

       usb_add host:1234:5678

   Normally the guest OS should report that a new USB device is plugged. You can use the option ``-usbdevice'` to do the same.
6. Now you can try to use the host USB device in QEMU.

When relaunching QEMU, you may have to unplug and plug again the USB device to make it work again (this is a bug).

## 3.10 GDB usage

QEMU has a primitive support to work with gdb, so that you can do 'Ctrl-C' while the virtual machine is running and inspect its state.

In order to use gdb, launch qemu with the '-s' option. It will wait for a gdb connection:

    > qemu -s -kernel arch/i386/boot/bzImage -hda root-2.4.20.img \
           -append "root=/dev/hda"
    Connected to host network interface: tun0
    Waiting gdb connection on port 1234

Then launch gdb on the 'vmlinux' executable:

    > gdb vmlinux

In gdb, connect to QEMU:

    (gdb) target remote localhost:1234

Then you can use gdb normally. For example, type 'c' to launch the kernel:

    (gdb) c

Here are some useful tips in order to use gdb on system code:

1. Use `info reg` to display all the CPU registers.
2. Use `x/10i $eip` to display the code at the PC position.
3. Use `set architecture i8086` to dump 16 bit code. Then use `x/10i $cs*16+*eip` to dump the code at the PC position.

## 3.11 Target OS specific information

### 3.11.1 Linux

To have access to SVGA graphic modes under X11, use the `vesa` or the `cirrus` X11 driver. For optimal performances, use 16 bit color depth in the guest and the host OS.

When using a 2.6 guest Linux kernel, you should add the option `clock=pit` on the kernel command line because the 2.6 Linux kernels make very strict real time clock checks by default that QEMU cannot simulate exactly.

When using a 2.6 guest Linux kernel, verify that the 4G/4G patch is not activated because QEMU is slower with this patch. The QEMU Accelerator Module is also much slower in this case. Earlier Fedora Core 3 Linux kernel (< 2.6.9-1.724_FC3) were known to incorporte this patch by default. Newer kernels don't have it.

### 3.11.2 Windows

If you have a slow host, using Windows 95 is better as it gives the best speed. Windows 2000 is also a good choice.

#### 3.11.2.1 SVGA graphic modes support

QEMU emulates a Cirrus Logic GD5446 Video card. All Windows versions starting from Windows 95 should recognize and use this graphic card. For optimal performances, use 16 bit color depth in the guest and the host OS.

#### 3.11.2.2 CPU usage reduction

Windows 9x does not correctly use the CPU HLT instruction. The result is that it takes host CPU cycles even when idle. You can install the utility from http://www.user.cityline.ru/~maxamn/amnhltm.zip to solve this problem. Note that no such tool is needed for NT, 2000 or XP.

#### 3.11.2.3 Windows 2000 disk full problem

Windows 2000 has a bug which gives a disk full problem during its installation. When installing it, use the ``-win2k-hack'` QEMU option to enable a specific workaround. After Windows 2000 is installed, you no longer need this option (this option slows down the IDE transfers).

#### 3.11.2.4 Windows 2000 shutdown

Windows 2000 cannot automatically shutdown in QEMU although Windows 98 can. It comes from the fact that Windows 2000 does not automatically use the APM driver provided by the BIOS.

In order to correct that, do the following (thanks to Struan Bartlett): go to the Control Panel => Add/Remove Hardware & Next => Add/Troubleshoot a device => Add a new device & Next => No, select the hardware from a list & Next => NT Apm/Legacy Support & Next => Next (again) a few times. Now the driver is installed and Windows 2000 now correctly instructs QEMU to shutdown at the appropriate moment.

#### 3.11.2.5 Share a directory between Unix and Windows

See section 3.3 Invocation about the help of the option ``-smb'`.

#### 3.11.2.6 Windows XP security problems

Some releases of Windows XP install correctly but give a security error when booting:

    A problem is preventing Windows from accurately checking the
    license for this computer. Error code: 0x800703e6.

The only known workaround is to boot in Safe mode without networking support.

Future QEMU releases are likely to correct this bug.

### 3.11.3 MS-DOS and FreeDOS

#### 3.11.3.1 CPU usage reduction

DOS does not correctly use the CPU HLT instruction. The result is that it takes host CPU cycles even when idle. You can install the utility from http://www.vmware.com/software/dosidle210.zip to solve this problem.

# 4. QEMU System emulator for non PC targets

QEMU is a generic emulator and it emulates many non PC machines. Most of the options are similar to the PC emulator. The differences are mentionned in the following sections.

## 4.1 QEMU PowerPC System emulator

Use the executable ``qemu-system-ppc'` to simulate a complete PREP or PowerMac PowerPC system.

QEMU emulates the following PowerMac peripherals:

- UniNorth PCI Bridge
- PCI VGA compatible card with VESA Bochs Extensions
- 2 PMAC IDE interfaces with hard disk and CD-ROM support
- NE2000 PCI adapters
- Non Volatile RAM
- VIA-CUDA with ADB keyboard and mouse.

QEMU emulates the following PREP peripherals:

- PCI Bridge
- PCI VGA compatible card with VESA Bochs Extensions
- 2 IDE interfaces with hard disk and CD-ROM support
- Floppy disk
- NE2000 network adapters
- Serial port
- PREP Non Volatile RAM
- PC compatible keyboard and mouse.

QEMU uses the Open Hack'Ware Open Firmware Compatible BIOS available at http://perso.magic.fr/l_indien/OpenHackWare/index.htm.

The following options are specific to the PowerPC emulation:

``-g WxH[xDEPTH]'`
  Set the initial VGA graphic mode. The default is 800x600x15.

More information is available at http://perso.magic.fr/l_indien/qemu-ppc/.

## 4.2 Sparc32 System emulator invocation

Use the executable ``qemu-system-sparc'` to simulate a JavaStation (sun4m architecture). The emulation is somewhat complete.

QEMU emulates the following sun4m peripherals:

- IOMMU
- TCX Frame buffer
- Lance (Am7990) Ethernet
- Non Volatile RAM M48T08
- Slave I/O: timers, interrupt controllers, Zilog serial ports, keyboard and power/reset logic
- ESP SCSI controller with hard disk and CD-ROM support
- Floppy drive

The number of peripherals is fixed in the architecture.

QEMU uses the Proll, a PROM replacement available at http://people.redhat.com/@/zaitcev/linux/. The required QEMU-specific patches are included with the sources.

A sample Linux 2.6 series kernel and ram disk image are available on the QEMU web site. Please note that currently neither Linux 2.4 series, NetBSD, nor OpenBSD kernels work.

The following options are specific to the Sparc emulation:

``-g WxH'`
  Set the initial TCX graphic mode. The default is 1024x768.

## 4.3 Sparc64 System emulator invocation

Use the executable ``qemu-system-sparc64'` to simulate a Sun4u machine. The emulator is not usable for anything yet.

QEMU emulates the following sun4u peripherals:

- UltraSparc IIi APB PCI Bridge
- PCI VGA compatible card with VESA Bochs Extensions
- Non Volatile RAM M48T59
- PC-compatible serial ports

## 4.4 MIPS System emulator invocation

Use the executable ``qemu-system-mips'` to simulate a MIPS machine. The emulator is able to boot a Linux kernel and to run a Linux Debian installation from NFS. The following devices are emulated:

- MIPS R4K CPU
- PC style serial port
- NE2000 network card

More information is available in the QEMU mailing-list archive.

## 4.5 ARM System emulator invocation

Use the executable ``qemu-system-arm'` to simulate a ARM machine. The ARM Integrator/CP board is emulated with the following devices:

- ARM926E or ARM1026E CPU
- Two PL011 UARTs
- SMC 91c111 Ethernet adapter

A Linux 2.6 test image is available on the QEMU web site. More information is available in the QEMU mailing-list archive.

# 5. QEMU Linux User space emulator

## 5.1 Quick Start

In order to launch a Linux process, QEMU needs the process executable itself and all the target (x86) dynamic libraries used by it.

- On x86, you can just try to launch any process by using the native libraries:

      qemu-i386 -L / /bin/ls

  `-L /` tells that the x86 dynamic linker must be searched with a ``/'` prefix.
- Since QEMU is also a linux process, you can launch qemu with qemu (NOTE: you can only do that if you compiled QEMU from the sources):

      qemu-i386 -L / qemu-i386 -L / /bin/ls

- On non x86 CPUs, you need first to download at least an x86 glibc (``qemu-runtime-i386-XXX-.tar.gz'` on the QEMU web page). Ensure that `LD_LIBRARY_PATH` is not set:

      unset LD_LIBRARY_PATH

  Then you can launch the precompiled ``ls'` x86 executable:

      qemu-i386 tests/i386/ls

  You can look at ``qemu-binfmt-conf.sh'` so that QEMU is automatically launched by the Linux kernel when you try to launch x86 executables. It requires the `binfmt_misc` module in the Linux kernel.
- The x86 version of QEMU is also included. You can try weird things such as:

      qemu-i386 /usr/local/qemu-i386/bin/qemu-i386 \
                /usr/local/qemu-i386/bin/ls-i386

## 5.2 Wine launch

- Ensure that you have a working QEMU with the x86 glibc distribution (see previous section). In order to verify it, you must be able to do:

      qemu-i386 /usr/local/qemu-i386/bin/ls-i386

- Download the binary x86 Wine install (``qemu-XXX-i386-wine.tar.gz'` on the QEMU web page).
- Configure Wine on your account. Look at the provided script ``/usr/local/qemu-i386/@/bin/wine-conf.sh'`. Your previous `${HOME}/.wine` directory is saved to `${HOME}/.wine.org`.
- Then you can try the example ``putty.exe'`:

      qemu-i386 /usr/local/qemu-i386/wine/bin/wine \
                /usr/local/qemu-i386/wine/c/Program\ Files/putty.exe

## 5.3 Command line options

    usage: qemu-i386 [-h] [-d] [-L path] [-s size] program [arguments...]

``-h'`
  Print the help
``-L path'`
  Set the x86 elf interpreter prefix (default=/usr/local/qemu-i386)
``-s size'`
  Set the x86 stack size in bytes (default=524288)

Debug options:

``-d'`
  Activate log (logfile=/tmp/qemu.log)
``-p pagesize'`
  Act as if the host page size was 'pagesize' bytes

# 6. Compilation from the sources

## 6.1 Linux/Unix

### 6.1.1 Compilation

First you must decompress the sources:

    cd /tmp
    tar zxvf qemu-x.y.z.tar.gz
    cd qemu-x.y.z

Then you configure QEMU and build it (usually no options are needed):

    ./configure
    make

Then type as root user:

    make install

to install QEMU in ``/usr/local'`.

### 6.1.2 Tested tool versions

In order to compile QEMU succesfully, it is very important that you have the right tools. The most important one is gcc. I cannot guaranty that QEMU works if you do not use a tested gcc version. Look at 'configure' and 'Makefile' if you want to make a different gcc version work.

    host      gcc      binutils      glibc    linux       distribution
    ----------------------------------------------------------------------
    x86       3.2      2.13.2        2.1.3    2.4.18
              2.96     2.11.93.0.2   2.2.5    2.4.18      Red Hat 7.3
              3.2.2    2.13.90.0.18  2.3.2    2.4.20      Red Hat 9

    PowerPC   3.3 [4]  2.13.90.0.18  2.3.1    2.4.20briq
              3.2

    Alpha     3.3 [1]  2.14.90.0.4   2.2.5    2.2.20 [2]  Debian 3.0

    Sparc32   2.95.4   2.12.90.0.1   2.2.5    2.4.18      Debian 3.0

    ARM       2.95.4   2.12.90.0.1   2.2.5    2.4.9 [3]   Debian 3.0

    [1] On Alpha, QEMU needs the gcc 'visibility' attribute only available
        for gcc version >= 3.3.
    [2] Linux >= 2.4.20 is necessary for precise exception support
        (untested).
    [3] 2.4.9-ac10-rmk2-np1-cerf2

    [4] gcc 2.95.x generates invalid code when using too many register
    variables. You must use gcc 3.x on PowerPC.

## 6.2 Windows

- Install the current versions of MSYS and MinGW from http://www.mingw.org/. You can find detailed installation instructions in the download section and the FAQ.
- Download the MinGW development library of SDL 1.2.x (``SDL-devel-1.2.x-@/mingw32.tar.gz'`) from http://www.libsdl.org. Unpack it in a temporary place, and unpack the archive ``i386-mingw32msvc.tar.gz'` in the MinGW tool directory. Edit the ``sdl-config'` script so that it gives the correct SDL directory when invoked.
- Extract the current version of QEMU.
- Start the MSYS shell (file ``msys.bat'`).
- Change to the QEMU directory. Launch ``./configure'` and ``make'`. If you have problems using SDL, verify that ``sdl-config'` can be launched from the MSYS command line.
- You can install QEMU in ``Program Files/Qemu'` by typing ``make install'`. Don't forget to copy ``SDL.dll'` in ``Program Files/Qemu'`.

## 6.3 Cross compilation for Windows with Linux

- Install the MinGW cross compilation tools available at http://www.mingw.org/.
- Install the Win32 version of SDL (http://www.libsdl.org) by unpacking ``i386-mingw32msvc.tar.gz'`. Set up the PATH environment variable so that ``i386-mingw32msvc-sdl-config'` can be launched by the QEMU configuration script.
- Configure QEMU for Windows cross compilation:

      ./configure --enable-mingw32

  If necessary, you can change the cross-prefix according to the prefix choosen for the MinGW tools with --cross-prefix. You can also use --prefix to set the Win32 install path.
- You can install QEMU in the installation directory by typing ``make install'`. Don't forget to copy ``SDL.dll'` in the installation directory.

Note: Currently, Wine does not seem able to launch QEMU for Win32.

## 6.4 Mac OS X

The Mac OS X patches are not fully merged in QEMU, so you should look at the QEMU mailing list archive to have all the necessary information.

# 7. Index

Jump to:

This document was generated on 3 May 2006 using texi2html 1.56k.